.clearfix:before,
.clearfix:after {
  content: ".";
  display: block;
  height: 0;
  overflow: hidden;
}
.clearfix:after {
  clear: both;
}
.clearfix {
  zoom: 1;
}

@each $size in 0, 25, 50, 75, 100, 125, 150, 175, 200, 225, 250, 275, 300, 325,
  350, 375, 400, 425, 450, 475, 500, 525, 550, 575, 600, 625, 650, 675, 700
{
  $value: calc($size/100);

  .mt#{$size},
  .m0.mt#{$size} {
    margin-top: #{$value}em;
  }

  .mb#{$size},
  .m0.mb#{$size} {
    margin-bottom: #{$value}em;
  }

  .pt#{$size},
  .p0.pt#{$size} {
    padding-top: #{$value}em;
  }

  .pb#{$size},
  .p0.pb#{$size} {
    padding-bottom: #{$value}em;
  }

  // Higher-priority (for print mode).
  .mt#{$size}i {
    margin-top: #{$value}em !important;
  }

  .mb#{$size}i {
    margin-bottom: #{$value}em !important;
  }

  .pt#{$size}i {
    padding-top: #{$value}em !important;
  }

  .pb#{$size}i {
    padding-bottom: #{$value}em !important;
  }
}

@each $theme in bleu-1, bleu-2, vert-1, vert-2, jaune-1, orange-1, orange-2,
  rouge-1, rose-1, violet-1
{
  .color-#{$theme} {
    color: var(--#{$theme});
  }

  .color-#{$theme}-hover:hover {
    color: var(--#{$theme});
  }

  .color-#{$theme}-dark {
    color: var(--#{$theme}-dark);
  }

  .color-#{$theme}-dark-hover:hover {
    color: var(--#{$theme}-dark);
  }

  .bg-#{$theme} {
    background: var(--#{$theme});
  }

  .bg-#{$theme}-hover:hover {
    background: var(--#{$theme}-hover);
    border-color: var(--#{$theme}-hover);
  }

  .bg-#{$theme}-dark {
    background: var(--#{$theme}-dark);
  }

  .modal-#{$theme} {
    button.close-popup {
      border-color: var(--#{$theme}-dark);

      svg {
        fill: var(--#{$theme}-dark);
      }

      &:hover {
        background-color: var(--#{$theme}-dark);
        border-color: var(--#{$theme}-dark);
        color: var(--#{$theme});

        svg {
          fill: var(--#{$theme});
        }
      }
    }
  }

  .modal-#{$theme}-mobile {
    @include phone() {
      button.close-popup {
        border-color: var(--#{$theme});

        svg {
          fill: var(--#{$theme});
        }

        &:hover {
          background-color: var(--#{$theme});
          border-color: var(--#{$theme});
          color: var(--#{$theme}-dark);

          svg {
            fill: var(--#{$theme}-dark);
          }
        }
      }
    }
  }

  .theme-#{$theme} {
    &.mini-card {
      div.card-content {
        > p.pre-title,
        > h3 {
          color: var(--#{$theme}-dark);
        }
      }
    }

    &.selected {
      background: var(--#{$theme});
    }

    &.summary {
      background: var(--#{$theme});

      > h3,
      > div.description {
        color: var(--#{$theme}-dark);
      }

      div.icon {
        color: var(--#{$theme});
        background: var(--#{$theme}-dark);
      }

      svg {
        fill: var(--#{$theme});
      }
    }

    div.icon {
      background: var(--#{$theme});
    }

    &:hover {
      background: var(--#{$theme});
    }
  }

  .icon-#{$theme}-dark {
    svg {
      fill: var(--#{$theme}-dark);
    }
  }

  .theme-#{$theme}-dark,
  .theme-#{$theme}-dark-hover:hover {
    &.mini-card {
      div.card-content {
        > p.pre-title,
        > h3 {
          color: var(--#{$theme});
        }
      }
    }

    &.summary {
      background: var(--#{$theme}-dark);

      > h3,
      > div.description {
        color: var(--#{$theme});
      }

      div.icon {
        color: var(--#{$theme}-dark);
        background: var(--#{$theme});
      }

      svg {
        fill: var(--#{$theme}-dark);
      }
    }

    &.selected {
      background: var(--#{$theme}-dark);
      color: #fff;

      button.active {
        background: var(--#{$theme});
        color: var(--#{$theme}-dark);

        svg {
          fill: var(--#{$theme}-dark);
        }
      }

      div.icon {
        background: transparent;

        svg {
          fill: var(--#{$theme});
        }
      }
    }

    &.icon {
      background: var(--#{$theme}-dark) !important;

      svg {
        fill: var(--#{$theme});
      }
    }

    &:hover {
      background: var(--#{$theme}-dark);

      button:not(.active) {
        border-color: var(--#{$theme});
        color: var(--#{$theme});

        svg {
          fill: var(--#{$theme});
        }

        &:hover {
          background: var(--#{$theme});
          border-color: var(--#{$theme});
          color: var(--#{$theme}-dark);
        }
      }
    }
  }

  button.theme-#{$theme},
  .button.theme-#{$theme} {
    color: var(--#{$theme}-dark);
    background: var(--#{$theme});
    border-color: var(--#{$theme});

    svg {
      fill: var(--#{$theme}-dark);
    }

    &:hover {
      background: transparent;
      color: var(--#{$theme});
      border-color: var(--#{$theme});

      svg {
        fill: var(--#{$theme});
      }
    }
  }

  button.theme-#{$theme}-dark,
  .button.theme-#{$theme}-dark {
    color: var(--#{$theme});
    background: var(--#{$theme}-dark);
    border-color: var(--#{$theme}-dark);

    svg {
      fill: var(--#{$theme});
    }

    &:hover {
      background: transparent;
      color: var(--#{$theme}-dark);
      border-color: var(--#{$theme}-dark);

      svg {
        fill: var(--#{$theme}-dark);
      }
    }
  }

  button.theme-#{$theme}-light-hover,
  .button.theme-#{$theme}-light-hover {
    &:hover {
      color: var(--#{$theme}-dark);
      background: var(--#{$theme});
      border-color: var(--#{$theme});

      svg {
        fill: var(--#{$theme}-dark);
      }
    }
  }

  button.theme-#{$theme}-hover:hover,
  .button.theme-#{$theme}-hover:hover {
    color: var(--#{$theme});
    background: var(--#{$theme}-dark);
    border-color: var(--#{$theme}-dark);

    svg {
      fill: var(--#{$theme});
    }
  }

  button.theme-#{$theme}-outline,
  .button.theme-#{$theme}-outline {
    border-color: var(--#{$theme}-dark);
    color: var(--#{$theme}-dark);

    svg {
      fill: var(--#{$theme}-dark);
    }
  }
}

.color-vert-1-alt {
  color: var(--vert-1-alt);
}

.db {
  display: block;
  width: 100%;
}

.m0 {
  margin: 0;
}

.p0 {
  padding: 0;
}

.mla {
  margin-left: auto;
}

.mra {
  margin-right: auto;
}

.fl {
  float: left;
}

.fr {
  float: right;
}

.fwb {
  font-weight: bold;
}

.fwn {
  font-weight: normal;
}

.fsi {
  font-style: italic;
}

.flex-column {
  display: flex;
  flex-direction: column;
}

.flex {
  flex: 1;
}

.flex-row {
  display: flex;
  flex-direction: row;

  @include phone() {
    &:not(.flex-row-mobile) {
      display: block;

      > .mla {
        margin-top: 1rem;
      }
    }
  }

  div.button-container {
    margin-bottom: 0.5rem;
    margin-left: 0.5rem;

    button {
      height: 2.4rem;
    }

    @include phone() {
      margin-left: 0;

      button {
        width: 100%;
      }
    }
  }
}

.flex-valign-center {
  align-items: center;
}

.flex-valign-bottom {
  align-items: flex-end;
}

.full-height {
  height: 100%;
  display: flex;
  flex-direction: column;
  // align-items: flex-start;

  & .fr {
    align-self: flex-end;
  }
}

.mta {
  margin-top: auto;
}
